#include <cstdlib>
#include <iostream>
#include <type_traits>

#include "version.h"

void call_test(char *) { std::cout << "call_test(char *) called" << std::endl; }

void call_test(int) { std::cout << "call_test(int) called" << std::endl; }

int main(int argc, char **argv) {

  std::cout << "Running " << PROJECT_NAME << ", version " << VERSION << "\n"
            << std::endl;

  if (std::is_same<decltype(NULL), decltype(0)>::value) {
    std::cout << "NULL == 0" << std::endl;
  }

  if (std::is_same<decltype(NULL), decltype((void *)0)>::value) {
    std::cout << "NULL == (void *)0" << std::endl;
  }

  if (std::is_same<decltype(NULL), decltype(__null)>::value) {
    std::cout << "NULL == __null" << std::endl;
  }

  if (std::is_same<decltype(NULL), std::nullptr_t>::value) {
    std::cout << "NULL == nullptr" << std::endl;
  }

  call_test(0);
  call_test(nullptr);

  std::cout << "\nExiting" << std::endl;

  return EXIT_SUCCESS;
}
